#include <stdio.h>
#include <ctype.h>
#include <assert.h>

/* Be careful; people might have strange texts */
#define MAXWORDLENGTH 1024


int main(int argc, char **argv) 
{
	int pos, i, whitespaceline;
	char buf[MAXWORDLENGTH];
	int c;

	int len = 70; /* intended line length */

	for (i=1; i<argc; i++) {
		if (!strcmp(argv[i],"-n")) {
			i++;
			if (i<argc) {
				len = atoi(argv[i]);
			} else {
				fprintf(stderr,"Option -n requires additional argument\n");
				return 1;
			}
		} else {
			fprintf(stderr,"Uknown option %s\n",argv[i]);
			return 1;
		}
	}
				


	pos=0; i=0; whitespaceline = 1;
	while((c=getchar())!=EOF) {
		if (!isspace(c)) {
			buf[i++]=c;
			assert(i<MAXWORDLENGTH);
			whitespaceline = 0;
		} else {
			/* end of word */ 
			buf[i] = '\0';
			/* decide on which line to put it */
			if (c=='\n' && whitespaceline) {
				/* new paragraph */
				if (pos!=0) printf("\n");
				printf("\n");
				pos=0;
				i=0;
			} else if (1 + pos + i/2 < len) {
				/* fits on the same line */
				if (i>0)  {
					if (pos !=0) {
						printf(" ");
						i++;
					}
					printf("%s", buf);
					pos += i;
					i=0;
				}
			} else {
				/* linebreak */
				printf("\n%s",buf);
				pos = i;
				i = 0;
			}
			if (c=='\n') {
				whitespaceline=1;
			}
		}
	}
	return 0;
}
