#include <curses.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define COLSEP 5

int main(int argc, char **argv) {
	int ymax,xmax,x,y;
	int colstart=0;
	int colmax=1;
	char *colsep = "  |  ";
	int colseplen;

	FILE *tty;

	int i,c;

	for (i=1; i<argc; i++) {
		if (!strcmp(argv[i],"-s")) {
			i++;
			if (i<argc) {
				colsep = argv[i];
			} else {
				fprintf(stderr,"Option -s requires additional argument\n");
				return 1;
			}
		} else {
			fprintf(stderr,"Uknown option %s\n",argv[i]);
			return 1;
		}
	}
	colseplen = strlen(colsep);


	cbreak();
	if ((tty = fopen("/dev/tty","r"))==NULL) {
		fprintf(stderr,"Failed to open /dev/tty\n");
		return 1;
	}


	initscr();
	getmaxyx(stdscr,ymax,xmax);
	x=0; y=0;

	while((c=getchar())!=EOF) {
		if (x>colmax) colmax = x;
		if (c != '\n') {
			if (isspace(c)) c=' ';
			move(y,x); addch(c);
			refresh();
			x++;
		} else {
			/* linebreak */
			y++;
			x=colstart;
			if (y==ymax-1) {
				/* end of colum */
				if (2 * colmax - colstart + 1 + 2*colseplen < xmax) {
					/* space enough for another column */
					
					/* draw a separation line */
					for(i=0; i<ymax -1; i++) {
						move(i,colmax);
						printw("%s",colsep);
					}
					refresh();

					/* Parameters for next column */ 
					colstart = colmax + colseplen;
					colmax = colstart + 1;
					y=0;
					x = colstart;
				} else {
					/* End of page */
					move(ymax-1,0);
					attron(A_REVERSE);
					printw("---MORE---");
					attroff(A_REVERSE);
					refresh();
					c = getc(tty);
					if (c=='q') {
						fclose(tty);
						endwin();
						return 0;
					}
					colstart=0; colmax = 1;
					x = 0; y = 0;
					clear(); refresh();
				}
			}
		}
	}	
	
	move(ymax-1,0);
	attron(A_REVERSE);
	printw("---END---");
	attroff(A_REVERSE);
	refresh();
	c = getc(tty);
	fclose(tty);
	endwin();
	return 0;
	
}
